/* 
  Created by Malay K. Ganai (malay@ece.utexas.edu) on 1999/07/17. 
  Improved hash function as suggested by
  Robert J. Jenkins Jr. in http://burtleburtle.net/bob/hash.
*/

#define mix(a,b,c){\
  a -= b; a -= c; a ^= (c>>13); \
  b -= c; b -= a; b ^= (a<<8);  \
  c -= a; c -= b; c ^= (b>>13); \
  a -= b; a -= c; a ^= (c>>12); \
  b -= c; b -= a; b ^= (a<<16); \
  c -= a; c -= b; c ^= (b>>5);  \
  a -= b; a -= c; a ^= (c>>3);  \
  b -= c; b -= a; b ^= (a<<10); \
  c -= a; c -= b; c ^= (b>>15); \
}
  
/* hash function */
/* claim is that there is no "funnels" in the hash functions */
unsigned
hash(unsigned *words, int num_word, unsigned init_val)
{
  register int a,b,c;
  unsigned i=num_word;
  a = b = 0x9e3779b9;
  c = init_val;
  
  while(i>=3){
   a +=  words[0]; b += words[1]; c += words[2];
   mix(a,b,c);
   i -= 3; 
   words += 3;
  }
  c += num_word;
  switch(i){
  case 2: b += words[1];
  case 1: a += words[0];
  }
  mix(a,b,c);
  return c;
}
