/**CFile*****************************************************************
  FileName                   [siva_main.h]

  PackageName                [siva_core]

  Synopsis                   [top]

  Author                     [Malay K. Ganai]

  Comment                    [Last Modified: 01/12/01]

  Copyright                  [Copyright (C) 2000 University of Texas at Austin.
  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.]
******************************************************************************/


#include <sys/types.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <unistd.h>
#include "util.h"
#include "error.h"
#include "avl.h"
#include "var_set.h"
#include "array.h"
#include "st.h"


static char version_str[100];

/*---------------------------------------------------------------------------*/
static char *
siva_read_version(void)
{
  sprintf(version_str, "%s (compiled %s)", CUR_VER, CUR_DATE);
}

/*---------------------------------------------------------------------------*/
void
main(int  argc, char ** argv)
{
  int quit_flag = -1;
  
  if (argc > 1) {
    fprintf(stdout,"%s\n",siva_read_version());
    return;
  }
  Cmd_Init();
  siva_init();
  Cmd_CommandExecute("source -s ~/.sivarc");
  while ((quit_flag = Cmd_CommandExecute("source -ip -")) >= 0);
  siva_quit();
}


